
import java.io.IOException;

import org.jruby.IRuby;
import org.jruby.RubyClass;
import org.jruby.RubyHash;
import org.jruby.RubyModule;
import org.jruby.RubyNumeric;
import org.jruby.RubyString;
import org.jruby.runtime.Block;
import org.jruby.runtime.CallbackFactory;
import org.jruby.runtime.builtin.IRubyObject;
import org.jruby.exceptions.RaiseException;
import org.jruby.runtime.load.BasicLibraryService;

public class HpricotScanService implements BasicLibraryService {
       public static String NO_WAY_SERIOUSLY="*** This should not happen, please send a bug report with the HTML you're parsing to why@whytheluckystiff.net.  So sorry!";

       public void ELE(IRubyObject N) {
         if (tokend > tokstart || text) {
           IRubyObject raw_string = runtime.getNil();
           ele_open = false; text = false;
           if (tokstart != -1 && N != cdata && N != sym_text && N != procins && N != comment) { 
             raw_string = runtime.newString(new String(buf,tokstart,tokend-tokstart));
           } 
           rb_yield_tokens(N, tag[0], attr, raw_string, taint);
         }
       }

       public void SET(IRubyObject[] N, int E) {
         int mark = 0;
         if(N == tag) { 
           if(mark_tag == -1 || E == mark_tag) {
             tag[0] = runtime.newString("");
           } else if(E > mark_tag) {
             tag[0] = runtime.newString(new String(buf,mark_tag, E-mark_tag));
           }
         } else if(N == akey) {
           if(mark_akey == -1 || E == mark_akey) {
             akey[0] = runtime.newString("");
           } else if(E > mark_akey) {
             akey[0] = runtime.newString(new String(buf,mark_akey, E-mark_akey));
           }
         } else if(N == aval) {
           if(mark_aval == -1 || E == mark_aval) {
             aval[0] = runtime.newString("");
           } else if(E > mark_aval) {
             aval[0] = runtime.newString(new String(buf,mark_aval, E-mark_aval));
           }
         }
       }

       public void CAT(IRubyObject[] N, int E) {
         if(N[0].isNil()) {
           SET(N,E);
         } else {
           int mark = 0;
           if(N == tag) {
             mark = mark_tag;
           } else if(N == akey) {
             mark = mark_akey;
           } else if(N == aval) {
             mark = mark_aval;
           }
           ((RubyString)(N[0])).cat(new String(buf, mark, E-mark));
         }
       }

       public void SLIDE(Object N) {
           int mark = 0;
           if(N == tag) {
             mark = mark_tag;
           } else if(N == akey) {
             mark = mark_akey;
           } else if(N == aval) {
             mark = mark_aval;
           }
           if(mark > tokstart) {
             if(N == tag) {
               mark_tag  -= tokstart;
             } else if(N == akey) {
               mark_akey -= tokstart;
             } else if(N == aval) {
               mark_aval -= tokstart;
             }
           }
       }

       public void ATTR(IRubyObject K, IRubyObject V) {
         if(!K.isNil()) {
           if(attr.isNil()) {
             attr = RubyHash.newHash(runtime);
           }
           ((RubyHash)attr).aset(K,V);
         }
       }

       public void ATTR(IRubyObject[] K, IRubyObject V) {
         ATTR(K[0],V);
       }

       public void ATTR(IRubyObject K, IRubyObject[] V) {
         ATTR(K,V[0]);
       }

       public void ATTR(IRubyObject[] K, IRubyObject[] V) {
         ATTR(K[0],V[0]);
       }

       public void TEXT_PASS() {
         if(!text) { 
           if(ele_open) { 
             ele_open = false; 
             if(tokstart > -1) { 
               mark_tag = tokstart; 
             } 
           } else {
             mark_tag = p; 
           } 
           attr = runtime.getNil(); 
           tag[0] = runtime.getNil(); 
           text = true; 
         }
       }

       public void EBLK(IRubyObject N, int T) {
         CAT(tag, p - T + 1);
         ELE(N);
       }


       public void rb_raise(RubyClass error, String message) {
              throw new RaiseException(runtime, error, message, true);
       }

       public IRubyObject rb_str_new2(String s) {
              return runtime.newString(s);
       }




static final byte[] _hpricot_scan_actions = {
	0, 1, 1, 1, 2, 1, 4, 1, 
	5, 1, 6, 1, 7, 1, 8, 1, 
	9, 1, 10, 1, 11, 1, 12, 1, 
	14, 1, 16, 1, 20, 1, 21, 1, 
	22, 1, 24, 1, 25, 1, 26, 1, 
	28, 1, 29, 1, 30, 1, 32, 1, 
	33, 1, 38, 1, 39, 1, 40, 1, 
	41, 1, 42, 1, 43, 1, 44, 1, 
	45, 1, 46, 1, 47, 1, 48, 1, 
	49, 1, 50, 2, 2, 5, 2, 2, 
	6, 2, 2, 11, 2, 2, 12, 2, 
	2, 14, 2, 4, 39, 2, 4, 40, 
	2, 4, 41, 2, 5, 2, 2, 6, 
	14, 2, 7, 6, 2, 7, 14, 2, 
	11, 12, 2, 13, 3, 2, 14, 6, 
	2, 14, 40, 2, 15, 24, 2, 15, 
	28, 2, 15, 32, 2, 15, 45, 2, 
	17, 23, 2, 18, 27, 2, 19, 31, 
	2, 22, 34, 2, 22, 36, 3, 2, 
	6, 14, 3, 2, 14, 6, 3, 6, 
	7, 14, 3, 6, 14, 40, 3, 7, 
	14, 40, 3, 14, 6, 40, 3, 14, 
	13, 3, 3, 22, 0, 37, 3, 22, 
	2, 34, 3, 22, 14, 35, 4, 2, 
	14, 13, 3, 4, 6, 7, 14, 40, 
	4, 22, 2, 14, 35, 4, 22, 6, 
	14, 35, 4, 22, 7, 14, 35, 4, 
	22, 14, 6, 35, 5, 22, 2, 6, 
	14, 35, 5, 22, 2, 14, 6, 35, 
	5, 22, 6, 7, 14, 35
};

static final short[] _hpricot_scan_key_offsets = {
	0, 3, 4, 5, 6, 7, 8, 9, 
	10, 13, 22, 37, 44, 45, 46, 47, 
	48, 49, 52, 57, 69, 81, 86, 93, 
	94, 95, 100, 101, 105, 106, 107, 121, 
	135, 152, 169, 186, 203, 210, 212, 214, 
	220, 222, 227, 232, 238, 240, 245, 251, 
	265, 266, 267, 268, 269, 270, 271, 272, 
	273, 274, 275, 276, 282, 296, 300, 313, 
	326, 340, 354, 355, 365, 373, 386, 402, 
	419, 436, 444, 454, 472, 490, 499, 508, 
	522, 523, 538, 553, 555, 565, 575, 593, 
	611, 628, 645, 663, 681, 690, 700, 710, 
	720, 735, 737, 751, 752, 767, 782, 784, 
	794, 803, 820, 838, 856, 865, 875, 893, 
	911, 921, 939, 958, 974, 990, 993, 1003, 
	1013, 1031, 1049, 1067, 1077, 1095, 1110, 1125, 
	1135, 1154, 1171, 1173, 1187, 1197, 1211, 1213, 
	1222, 1223, 1224, 1234, 1241, 1254, 1268, 1282, 
	1295, 1296, 1297, 1298, 1299, 1300, 1301, 1305, 
	1310, 1319, 1329, 1333, 1339, 1340, 1341, 1342, 
	1343, 1344, 1345, 1346, 1347, 1351, 1356, 1360, 
	1370, 1374, 1379, 1380, 1381, 1382, 1383, 1384, 
	1385, 1386, 1387, 1388, 1392, 1397, 1399, 1400, 
	1401, 1405, 1406, 1407, 1409, 1410, 1411, 1412, 
	1413, 1417, 1427, 1436, 1446, 1447, 1448, 1450, 
	1459, 1460, 1461, 1462, 1463, 1464, 1466, 1469, 
	1473, 1475, 1476, 1478, 1479, 1481
};

static final char[] _hpricot_scan_trans_keys = {
	45, 68, 91, 45, 79, 67, 84, 89, 
	80, 69, 32, 9, 13, 32, 58, 95, 
	9, 13, 65, 90, 97, 122, 32, 62, 
	63, 91, 95, 9, 13, 45, 46, 48, 
	58, 65, 90, 97, 122, 32, 62, 80, 
	83, 91, 9, 13, 85, 66, 76, 73, 
	67, 32, 9, 13, 32, 34, 39, 9, 
	13, 9, 34, 61, 95, 32, 37, 39, 
	59, 63, 90, 97, 122, 9, 34, 61, 
	95, 32, 37, 39, 59, 63, 90, 97, 
	122, 32, 62, 91, 9, 13, 32, 34, 
	39, 62, 91, 9, 13, 34, 34, 32, 
	62, 91, 9, 13, 93, 32, 62, 9, 
	13, 39, 39, 9, 39, 61, 95, 32, 
	33, 35, 37, 40, 59, 63, 90, 97, 
	122, 9, 39, 61, 95, 32, 33, 35, 
	37, 40, 59, 63, 90, 97, 122, 9, 
	32, 33, 39, 62, 91, 95, 10, 13, 
	35, 37, 40, 59, 61, 90, 97, 122, 
	9, 32, 34, 39, 62, 91, 95, 10, 
	13, 33, 37, 40, 59, 61, 90, 97, 
	122, 9, 32, 33, 39, 62, 91, 95, 
	10, 13, 35, 37, 40, 59, 61, 90, 
	97, 122, 9, 32, 34, 39, 62, 91, 
	95, 10, 13, 33, 37, 40, 59, 61, 
	90, 97, 122, 32, 34, 39, 62, 91, 
	9, 13, 34, 39, 34, 39, 32, 39, 
	62, 91, 9, 13, 39, 93, 32, 62, 
	93, 9, 13, 32, 39, 62, 9, 13, 
	32, 34, 62, 91, 9, 13, 34, 93, 
	32, 34, 62, 9, 13, 32, 39, 62, 
	91, 9, 13, 9, 39, 61, 95, 32, 
	33, 35, 37, 40, 59, 63, 90, 97, 
	122, 89, 83, 84, 69, 77, 67, 68, 
	65, 84, 65, 91, 58, 95, 65, 90, 
	97, 122, 32, 62, 63, 95, 9, 13, 
	45, 46, 48, 58, 65, 90, 97, 122, 
	32, 62, 9, 13, 32, 47, 62, 63, 
	95, 9, 13, 45, 58, 65, 90, 97, 
	122, 32, 47, 62, 63, 95, 9, 13, 
	45, 58, 65, 90, 97, 122, 32, 47, 
	61, 62, 63, 95, 9, 13, 45, 58, 
	65, 90, 97, 122, 32, 47, 61, 62, 
	63, 95, 9, 13, 45, 58, 65, 90, 
	97, 122, 62, 32, 34, 39, 47, 60, 
	62, 9, 10, 11, 13, 32, 47, 60, 
	62, 9, 10, 11, 13, 32, 47, 62, 
	63, 95, 9, 13, 45, 58, 65, 90, 
	97, 122, 32, 47, 60, 62, 63, 95, 
	9, 10, 11, 13, 45, 58, 65, 90, 
	97, 122, 32, 47, 60, 61, 62, 63, 
	95, 9, 10, 11, 13, 45, 58, 65, 
	90, 97, 122, 32, 47, 60, 61, 62, 
	63, 95, 9, 10, 11, 13, 45, 58, 
	65, 90, 97, 122, 32, 47, 60, 62, 
	9, 10, 11, 13, 32, 34, 39, 47, 
	60, 62, 9, 10, 11, 13, 32, 34, 
	39, 47, 60, 62, 63, 95, 9, 10, 
	11, 13, 45, 58, 65, 90, 97, 122, 
	32, 34, 39, 47, 60, 62, 63, 95, 
	9, 10, 11, 13, 45, 58, 65, 90, 
	97, 122, 32, 34, 47, 60, 62, 9, 
	10, 11, 13, 32, 34, 47, 60, 62, 
	9, 10, 11, 13, 32, 34, 47, 62, 
	63, 95, 9, 13, 45, 58, 65, 90, 
	97, 122, 34, 32, 34, 47, 61, 62, 
	63, 95, 9, 13, 45, 58, 65, 90, 
	97, 122, 32, 34, 47, 61, 62, 63, 
	95, 9, 13, 45, 58, 65, 90, 97, 
	122, 34, 62, 32, 34, 39, 47, 60, 
	62, 9, 10, 11, 13, 32, 34, 39, 
	47, 60, 62, 9, 10, 11, 13, 32, 
	34, 39, 47, 60, 62, 63, 95, 9, 
	10, 11, 13, 45, 58, 65, 90, 97, 
	122, 32, 34, 39, 47, 60, 62, 63, 
	95, 9, 10, 11, 13, 45, 58, 65, 
	90, 97, 122, 32, 34, 47, 60, 62, 
	63, 95, 9, 10, 11, 13, 45, 58, 
	65, 90, 97, 122, 32, 34, 47, 60, 
	62, 63, 95, 9, 10, 11, 13, 45, 
	58, 65, 90, 97, 122, 32, 34, 47, 
	60, 61, 62, 63, 95, 9, 10, 11, 
	13, 45, 58, 65, 90, 97, 122, 32, 
	34, 47, 60, 61, 62, 63, 95, 9, 
	10, 11, 13, 45, 58, 65, 90, 97, 
	122, 32, 34, 47, 60, 62, 9, 10, 
	11, 13, 32, 34, 39, 47, 60, 62, 
	9, 10, 11, 13, 32, 34, 39, 47, 
	60, 62, 9, 10, 11, 13, 32, 34, 
	39, 47, 60, 62, 9, 10, 11, 13, 
	32, 34, 39, 47, 62, 63, 95, 9, 
	13, 45, 58, 65, 90, 97, 122, 34, 
	39, 32, 39, 47, 62, 63, 95, 9, 
	13, 45, 58, 65, 90, 97, 122, 39, 
	32, 39, 47, 61, 62, 63, 95, 9, 
	13, 45, 58, 65, 90, 97, 122, 32, 
	39, 47, 61, 62, 63, 95, 9, 13, 
	45, 58, 65, 90, 97, 122, 39, 62, 
	32, 34, 39, 47, 60, 62, 9, 10, 
	11, 13, 32, 39, 47, 60, 62, 9, 
	10, 11, 13, 32, 39, 47, 60, 62, 
	63, 95, 9, 10, 11, 13, 45, 58, 
	65, 90, 97, 122, 32, 39, 47, 60, 
	61, 62, 63, 95, 9, 10, 11, 13, 
	45, 58, 65, 90, 97, 122, 32, 39, 
	47, 60, 61, 62, 63, 95, 9, 10, 
	11, 13, 45, 58, 65, 90, 97, 122, 
	32, 39, 47, 60, 62, 9, 10, 11, 
	13, 32, 34, 39, 47, 60, 62, 9, 
	10, 11, 13, 32, 34, 39, 47, 60, 
	62, 63, 95, 9, 10, 11, 13, 45, 
	58, 65, 90, 97, 122, 32, 34, 39, 
	47, 60, 62, 63, 95, 9, 10, 11, 
	13, 45, 58, 65, 90, 97, 122, 32, 
	34, 39, 47, 60, 62, 9, 10, 11, 
	13, 32, 34, 39, 47, 60, 62, 63, 
	95, 9, 10, 11, 13, 45, 58, 65, 
	90, 97, 122, 32, 34, 39, 47, 60, 
	61, 62, 63, 95, 9, 10, 11, 13, 
	45, 58, 65, 90, 97, 122, 32, 34, 
	39, 47, 61, 62, 63, 95, 9, 13, 
	45, 58, 65, 90, 97, 122, 32, 34, 
	39, 47, 61, 62, 63, 95, 9, 13, 
	45, 58, 65, 90, 97, 122, 34, 39, 
	62, 32, 34, 39, 47, 60, 62, 9, 
	10, 11, 13, 32, 34, 39, 47, 60, 
	62, 9, 10, 11, 13, 32, 34, 39, 
	47, 60, 62, 63, 95, 9, 10, 11, 
	13, 45, 58, 65, 90, 97, 122, 32, 
	34, 39, 47, 60, 62, 63, 95, 9, 
	10, 11, 13, 45, 58, 65, 90, 97, 
	122, 32, 34, 39, 47, 60, 62, 63, 
	95, 9, 10, 11, 13, 45, 58, 65, 
	90, 97, 122, 32, 34, 39, 47, 60, 
	62, 9, 10, 11, 13, 32, 34, 39, 
	47, 60, 62, 63, 95, 9, 10, 11, 
	13, 45, 58, 65, 90, 97, 122, 32, 
	34, 39, 47, 62, 63, 95, 9, 13, 
	45, 58, 65, 90, 97, 122, 32, 34, 
	39, 47, 62, 63, 95, 9, 13, 45, 
	58, 65, 90, 97, 122, 32, 34, 39, 
	47, 60, 62, 9, 10, 11, 13, 32, 
	34, 39, 47, 60, 61, 62, 63, 95, 
	9, 10, 11, 13, 45, 58, 65, 90, 
	97, 122, 32, 39, 47, 60, 62, 63, 
	95, 9, 10, 11, 13, 45, 58, 65, 
	90, 97, 122, 34, 39, 32, 39, 47, 
	62, 63, 95, 9, 13, 45, 58, 65, 
	90, 97, 122, 32, 34, 39, 47, 60, 
	62, 9, 10, 11, 13, 32, 34, 47, 
	62, 63, 95, 9, 13, 45, 58, 65, 
	90, 97, 122, 34, 39, 32, 39, 47, 
	60, 62, 9, 10, 11, 13, 34, 39, 
	32, 34, 39, 47, 60, 62, 9, 10, 
	11, 13, 58, 95, 120, 65, 90, 97, 
	122, 32, 63, 95, 9, 13, 45, 46, 
	48, 58, 65, 90, 97, 122, 32, 63, 
	95, 109, 9, 13, 45, 46, 48, 58, 
	65, 90, 97, 122, 32, 63, 95, 108, 
	9, 13, 45, 46, 48, 58, 65, 90, 
	97, 122, 32, 63, 95, 9, 13, 45, 
	46, 48, 58, 65, 90, 97, 122, 101, 
	114, 115, 105, 111, 110, 32, 61, 9, 
	13, 32, 34, 39, 9, 13, 95, 45, 
	46, 48, 58, 65, 90, 97, 122, 34, 
	95, 45, 46, 48, 58, 65, 90, 97, 
	122, 32, 63, 9, 13, 32, 63, 101, 
	115, 9, 13, 62, 110, 99, 111, 100, 
	105, 110, 103, 32, 61, 9, 13, 32, 
	34, 39, 9, 13, 65, 90, 97, 122, 
	34, 95, 45, 46, 48, 57, 65, 90, 
	97, 122, 32, 63, 9, 13, 32, 63, 
	115, 9, 13, 116, 97, 110, 100, 97, 
	108, 111, 110, 101, 32, 61, 9, 13, 
	32, 34, 39, 9, 13, 110, 121, 111, 
	34, 32, 63, 9, 13, 101, 115, 110, 
	121, 111, 39, 101, 115, 65, 90, 97, 
	122, 39, 95, 45, 46, 48, 57, 65, 
	90, 97, 122, 95, 45, 46, 48, 58, 
	65, 90, 97, 122, 39, 95, 45, 46, 
	48, 58, 65, 90, 97, 122, 62, 62, 
	10, 60, 33, 47, 58, 63, 95, 65, 
	90, 97, 122, 39, 93, 34, 34, 39, 
	34, 39, 32, 9, 13, 32, 118, 9, 
	13, 10, 45, 45, 10, 93, 93, 10, 
	63, 62, 0
};

static final byte[] _hpricot_scan_single_lengths = {
	3, 1, 1, 1, 1, 1, 1, 1, 
	1, 3, 5, 5, 1, 1, 1, 1, 
	1, 1, 3, 4, 4, 3, 5, 1, 
	1, 3, 1, 2, 1, 1, 4, 4, 
	7, 7, 7, 7, 5, 2, 2, 4, 
	2, 3, 3, 4, 2, 3, 4, 4, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 2, 4, 2, 5, 5, 
	6, 6, 1, 6, 4, 5, 6, 7, 
	7, 4, 6, 8, 8, 5, 5, 6, 
	1, 7, 7, 2, 6, 6, 8, 8, 
	7, 7, 8, 8, 5, 6, 6, 6, 
	7, 2, 6, 1, 7, 7, 2, 6, 
	5, 7, 8, 8, 5, 6, 8, 8, 
	6, 8, 9, 8, 8, 3, 6, 6, 
	8, 8, 8, 6, 8, 7, 7, 6, 
	9, 7, 2, 6, 6, 6, 2, 5, 
	1, 1, 6, 3, 3, 4, 4, 3, 
	1, 1, 1, 1, 1, 1, 2, 3, 
	1, 2, 2, 4, 1, 1, 1, 1, 
	1, 1, 1, 1, 2, 3, 0, 2, 
	2, 3, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 2, 3, 2, 1, 1, 
	2, 1, 1, 2, 1, 1, 1, 1, 
	0, 2, 1, 2, 1, 1, 2, 5, 
	1, 1, 1, 1, 1, 2, 1, 2, 
	2, 1, 2, 1, 2, 1
};

static final byte[] _hpricot_scan_range_lengths = {
	0, 0, 0, 0, 0, 0, 0, 0, 
	1, 3, 5, 1, 0, 0, 0, 0, 
	0, 1, 1, 4, 4, 1, 1, 0, 
	0, 1, 0, 1, 0, 0, 5, 5, 
	5, 5, 5, 5, 1, 0, 0, 1, 
	0, 1, 1, 1, 0, 1, 1, 5, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 2, 5, 1, 4, 4, 
	4, 4, 0, 2, 2, 4, 5, 5, 
	5, 2, 2, 5, 5, 2, 2, 4, 
	0, 4, 4, 0, 2, 2, 5, 5, 
	5, 5, 5, 5, 2, 2, 2, 2, 
	4, 0, 4, 0, 4, 4, 0, 2, 
	2, 5, 5, 5, 2, 2, 5, 5, 
	2, 5, 5, 4, 4, 0, 2, 2, 
	5, 5, 5, 2, 5, 4, 4, 2, 
	5, 5, 0, 4, 2, 4, 0, 2, 
	0, 0, 2, 2, 5, 5, 5, 5, 
	0, 0, 0, 0, 0, 0, 1, 1, 
	4, 4, 1, 1, 0, 0, 0, 0, 
	0, 0, 0, 0, 1, 1, 2, 4, 
	1, 1, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 1, 1, 0, 0, 0, 
	1, 0, 0, 0, 0, 0, 0, 0, 
	2, 4, 4, 4, 0, 0, 0, 2, 
	0, 0, 0, 0, 0, 0, 1, 1, 
	0, 0, 0, 0, 0, 0
};

static final short[] _hpricot_scan_index_offsets = {
	0, 4, 6, 8, 10, 12, 14, 16, 
	18, 21, 28, 39, 46, 48, 50, 52, 
	54, 56, 59, 64, 73, 82, 87, 94, 
	96, 98, 103, 105, 109, 111, 113, 123, 
	133, 146, 159, 172, 185, 192, 195, 198, 
	204, 207, 212, 217, 223, 226, 231, 237, 
	247, 249, 251, 253, 255, 257, 259, 261, 
	263, 265, 267, 269, 274, 284, 288, 298, 
	308, 319, 330, 332, 341, 348, 358, 370, 
	383, 396, 403, 412, 426, 440, 448, 456, 
	467, 469, 481, 493, 496, 505, 514, 528, 
	542, 555, 568, 582, 596, 604, 613, 622, 
	631, 643, 646, 657, 659, 671, 683, 686, 
	695, 703, 716, 730, 744, 752, 761, 775, 
	789, 798, 812, 827, 840, 853, 857, 866, 
	875, 889, 903, 917, 926, 940, 952, 964, 
	973, 988, 1001, 1004, 1015, 1024, 1035, 1038, 
	1046, 1048, 1050, 1059, 1065, 1074, 1084, 1094, 
	1103, 1105, 1107, 1109, 1111, 1113, 1115, 1119, 
	1124, 1130, 1137, 1141, 1147, 1149, 1151, 1153, 
	1155, 1157, 1159, 1161, 1163, 1167, 1172, 1175, 
	1182, 1186, 1191, 1193, 1195, 1197, 1199, 1201, 
	1203, 1205, 1207, 1209, 1213, 1218, 1221, 1223, 
	1225, 1229, 1231, 1233, 1236, 1238, 1240, 1242, 
	1244, 1247, 1254, 1260, 1267, 1269, 1271, 1274, 
	1282, 1284, 1286, 1288, 1290, 1292, 1295, 1298, 
	1302, 1305, 1307, 1310, 1312, 1315
};

static final short[] _hpricot_scan_indicies = {
	309, 310, 311, 270, 330, 270, 323, 270, 
	385, 270, 387, 270, 328, 270, 324, 270, 
	386, 270, 282, 282, 270, 282, 283, 283, 
	282, 283, 283, 270, 302, 304, 303, 305, 
	303, 302, 303, 303, 303, 303, 270, 284, 
	276, 285, 286, 0, 284, 270, 327, 270, 
	316, 270, 321, 270, 320, 270, 317, 270, 
	278, 278, 270, 278, 279, 280, 278, 270, 
	295, 294, 295, 295, 295, 295, 295, 295, 
	270, 293, 294, 293, 293, 293, 293, 293, 
	293, 270, 272, 276, 0, 272, 270, 272, 
	274, 281, 276, 0, 272, 270, 5, 196, 
	5, 10, 332, 276, 0, 332, 62, 1, 
	0, 1, 276, 1, 62, 5, 160, 5, 
	4, 296, 297, 296, 296, 296, 296, 296, 
	296, 296, 270, 273, 277, 273, 273, 273, 
	273, 273, 273, 273, 270, 271, 271, 273, 
	277, 276, 0, 273, 272, 273, 273, 273, 
	273, 270, 271, 271, 274, 275, 276, 0, 
	273, 272, 273, 273, 273, 273, 270, 164, 
	164, 166, 38, 162, 163, 166, 165, 166, 
	166, 166, 166, 160, 39, 39, 34, 40, 
	36, 30, 37, 33, 37, 37, 37, 37, 
	4, 33, 34, 35, 36, 30, 33, 4, 
	56, 198, 197, 56, 57, 55, 346, 5, 
	36, 30, 346, 4, 31, 32, 30, 23, 
	24, 1, 23, 0, 32, 5, 36, 32, 
	4, 53, 5, 54, 51, 53, 10, 31, 
	52, 51, 52, 5, 54, 52, 10, 161, 
	5, 162, 163, 161, 160, 37, 38, 37, 
	37, 37, 37, 37, 37, 37, 4, 389, 
	270, 325, 270, 326, 270, 319, 270, 322, 
	270, 384, 270, 318, 270, 315, 270, 388, 
	270, 383, 270, 329, 270, 312, 312, 312, 
	312, 270, 306, 308, 307, 307, 306, 307, 
	307, 307, 307, 270, 287, 288, 287, 270, 
	298, 300, 301, 299, 299, 298, 299, 299, 
	299, 270, 289, 291, 292, 290, 290, 289, 
	290, 290, 290, 270, 338, 340, 341, 342, 
	339, 339, 338, 339, 339, 339, 62, 333, 
	335, 336, 142, 334, 334, 333, 334, 334, 
	334, 62, 343, 62, 137, 139, 140, 141, 
	62, 142, 137, 138, 136, 59, 61, 62, 
	63, 59, 60, 58, 337, 335, 142, 334, 
	334, 337, 334, 334, 334, 62, 59, 67, 
	62, 69, 66, 66, 59, 60, 66, 66, 
	66, 58, 112, 115, 62, 116, 117, 114, 
	114, 112, 113, 114, 114, 114, 58, 64, 
	67, 62, 68, 69, 66, 66, 64, 65, 
	66, 66, 66, 58, 59, 61, 62, 63, 
	59, 60, 58, 200, 202, 203, 204, 62, 
	63, 200, 201, 136, 143, 139, 140, 141, 
	62, 142, 145, 145, 143, 144, 145, 145, 
	145, 136, 200, 202, 203, 205, 62, 69, 
	145, 145, 200, 201, 145, 145, 145, 136, 
	222, 73, 220, 176, 224, 222, 223, 167, 
	80, 73, 82, 6, 83, 80, 81, 79, 
	42, 3, 44, 45, 43, 43, 42, 43, 
	43, 43, 6, 3, 6, 102, 3, 104, 
	105, 106, 103, 103, 102, 103, 103, 103, 
	6, 347, 3, 44, 348, 45, 43, 43, 
	347, 43, 43, 43, 6, 3, 41, 6, 
	168, 170, 171, 172, 6, 45, 168, 169, 
	167, 173, 170, 171, 172, 6, 45, 173, 
	174, 167, 173, 170, 171, 172, 6, 45, 
	175, 175, 173, 174, 175, 175, 175, 167, 
	216, 218, 219, 221, 6, 86, 175, 175, 
	216, 217, 175, 175, 175, 167, 222, 73, 
	221, 176, 225, 175, 175, 222, 223, 175, 
	175, 175, 167, 80, 73, 85, 6, 86, 
	84, 84, 80, 81, 84, 84, 84, 79, 
	124, 73, 127, 6, 128, 129, 126, 126, 
	124, 125, 126, 126, 126, 79, 354, 73, 
	85, 6, 356, 86, 84, 84, 354, 355, 
	84, 84, 84, 79, 80, 73, 82, 6, 
	83, 80, 81, 79, 216, 218, 219, 220, 
	6, 83, 216, 217, 167, 232, 237, 91, 
	230, 190, 235, 232, 233, 181, 88, 90, 
	91, 92, 7, 93, 88, 89, 87, 47, 
	8, 9, 49, 50, 48, 48, 47, 48, 
	48, 48, 7, 8, 9, 7, 26, 3, 
	28, 29, 27, 27, 26, 27, 27, 27, 
	2, 3, 2, 97, 3, 99, 100, 101, 
	98, 98, 97, 98, 98, 98, 2, 344, 
	3, 28, 345, 29, 27, 27, 344, 27, 
	27, 27, 2, 3, 25, 2, 147, 149, 
	150, 151, 2, 29, 147, 148, 146, 71, 
	73, 74, 2, 75, 71, 72, 70, 71, 
	73, 77, 2, 78, 76, 76, 71, 72, 
	76, 76, 76, 70, 118, 73, 121, 2, 
	122, 123, 120, 120, 118, 119, 120, 120, 
	120, 70, 351, 73, 77, 2, 353, 78, 
	76, 76, 351, 352, 76, 76, 76, 70, 
	71, 73, 74, 2, 75, 71, 72, 70, 
	206, 208, 209, 210, 2, 75, 206, 207, 
	146, 152, 149, 150, 151, 2, 29, 154, 
	154, 152, 153, 154, 154, 154, 146, 206, 
	208, 209, 211, 2, 78, 154, 154, 206, 
	207, 154, 154, 154, 146, 232, 90, 234, 
	230, 190, 235, 232, 233, 181, 88, 90, 
	91, 95, 7, 96, 94, 94, 88, 89, 
	94, 94, 94, 87, 130, 90, 91, 133, 
	7, 134, 135, 132, 132, 130, 131, 132, 
	132, 132, 87, 349, 8, 9, 49, 350, 
	50, 48, 48, 349, 48, 48, 48, 7, 
	107, 8, 9, 109, 110, 111, 108, 108, 
	107, 108, 108, 108, 7, 8, 9, 46, 
	7, 182, 184, 185, 186, 7, 50, 182, 
	183, 181, 187, 184, 185, 186, 7, 50, 
	187, 188, 181, 187, 184, 185, 186, 7, 
	50, 189, 189, 187, 188, 189, 189, 189, 
	181, 226, 228, 229, 231, 7, 96, 189, 
	189, 226, 227, 189, 189, 189, 181, 232, 
	90, 234, 231, 190, 236, 189, 189, 232, 
	233, 189, 189, 189, 181, 88, 90, 91, 
	92, 7, 93, 88, 89, 87, 232, 237, 
	91, 231, 190, 236, 189, 189, 232, 233, 
	189, 189, 189, 181, 192, 8, 191, 194, 
	195, 193, 193, 192, 193, 193, 193, 190, 
	192, 199, 9, 194, 195, 193, 193, 192, 
	193, 193, 193, 190, 226, 228, 229, 230, 
	7, 93, 226, 227, 181, 357, 90, 91, 
	95, 7, 359, 96, 94, 94, 357, 358, 
	94, 94, 94, 87, 212, 73, 211, 155, 
	215, 154, 154, 212, 213, 154, 154, 154, 
	146, 8, 191, 190, 156, 3, 158, 159, 
	157, 157, 156, 157, 157, 157, 155, 152, 
	149, 150, 151, 2, 29, 152, 153, 146, 
	177, 3, 179, 180, 178, 178, 177, 178, 
	178, 178, 176, 199, 9, 190, 212, 73, 
	210, 155, 214, 212, 213, 146, 3, 176, 
	3, 155, 143, 139, 140, 141, 62, 142, 
	143, 144, 136, 313, 313, 314, 313, 313, 
	270, 12, 331, 331, 12, 331, 331, 331, 
	331, 270, 12, 331, 331, 394, 12, 331, 
	331, 331, 331, 270, 12, 331, 331, 390, 
	12, 331, 331, 331, 331, 270, 13, 331, 
	331, 13, 331, 331, 331, 331, 270, 260, 
	238, 267, 238, 382, 238, 373, 238, 379, 
	238, 242, 238, 242, 239, 242, 238, 239, 
	240, 241, 239, 238, 255, 255, 255, 255, 
	255, 238, 248, 249, 249, 249, 249, 249, 
	238, 243, 244, 243, 238, 243, 244, 245, 
	246, 243, 238, 269, 238, 374, 238, 258, 
	238, 380, 238, 371, 238, 262, 238, 376, 
	238, 261, 238, 261, 360, 261, 238, 360, 
	361, 362, 360, 238, 256, 256, 238, 250, 
	251, 251, 251, 251, 251, 238, 247, 244, 
	247, 238, 247, 244, 246, 247, 238, 268, 
	238, 370, 238, 375, 238, 259, 238, 257, 
	238, 263, 238, 381, 238, 377, 238, 366, 
	238, 366, 363, 366, 238, 363, 364, 365, 
	363, 238, 264, 265, 238, 266, 238, 252, 
	238, 367, 244, 367, 238, 372, 238, 266, 
	238, 391, 392, 238, 378, 238, 252, 238, 
	393, 238, 378, 238, 369, 369, 238, 250, 
	254, 254, 254, 254, 254, 238, 368, 368, 
	368, 368, 368, 238, 248, 253, 253, 253, 
	253, 253, 238, 401, 400, 408, 407, 21, 
	22, 20, 16, 17, 18, 19, 18, 18, 
	18, 15, 5, 4, 1, 0, 5, 10, 
	3, 6, 3, 2, 8, 9, 7, 12, 
	12, 11, 13, 14, 13, 11, 398, 399, 
	397, 396, 395, 405, 406, 404, 403, 402, 
	412, 413, 411, 410, 409, 0
};

static final short[] _hpricot_scan_trans_targs_wi = {
	26, 27, 99, 69, 29, 25, 80, 97, 
	98, 79, 24, 198, 206, 207, 144, 198, 
	0, 59, 62, 139, 198, 198, 199, 41, 
	201, 204, 98, 100, 102, 204, 40, 41, 
	42, 36, 37, 46, 200, 47, 32, 35, 
	34, 203, 79, 81, 83, 203, 205, 96, 
	116, 117, 205, 44, 45, 43, 202, 38, 
	39, 43, 68, 69, 70, 73, 198, 198, 
	65, 72, 71, 73, 74, 198, 104, 98, 
	105, 70, 108, 204, 106, 108, 204, 78, 
	79, 89, 92, 203, 90, 92, 203, 95, 
	96, 113, 105, 89, 123, 205, 114, 123, 
	205, 101, 100, 102, 103, 204, 82, 81, 
	83, 84, 203, 115, 116, 117, 118, 205, 
	65, 72, 71, 73, 74, 198, 101, 107, 
	106, 108, 109, 204, 82, 91, 90, 92, 
	93, 203, 115, 128, 114, 123, 127, 205, 
	68, 138, 74, 136, 137, 73, 198, 75, 
	76, 71, 104, 132, 109, 130, 131, 108, 
	110, 111, 106, 99, 98, 100, 102, 204, 
	29, 39, 200, 40, 35, 36, 47, 78, 
	85, 93, 133, 134, 92, 86, 87, 90, 
	80, 79, 81, 83, 203, 95, 119, 127, 
	125, 126, 123, 120, 121, 114, 97, 79, 
	96, 116, 117, 205, 24, 38, 43, 98, 
	75, 76, 77, 135, 73, 73, 110, 111, 
	112, 129, 108, 108, 98, 105, 204, 204, 
	86, 87, 88, 94, 92, 92, 79, 89, 
	203, 203, 120, 121, 122, 124, 123, 123, 
	96, 113, 89, 205, 205, 105, 198, 151, 
	152, 194, 150, 155, 156, 157, 170, 169, 
	154, 153, 168, 167, 184, 195, 193, 153, 
	167, 175, 159, 174, 145, 164, 162, 176, 
	182, 185, 183, 146, 171, 198, 198, 33, 
	22, 31, 23, 34, 198, 32, 18, 19, 
	30, 28, 9, 10, 11, 12, 48, 61, 
	198, 63, 64, 66, 198, 20, 21, 20, 
	31, 32, 63, 62, 66, 198, 11, 10, 
	198, 26, 61, 60, 198, 1, 2, 53, 
	60, 140, 141, 56, 14, 17, 55, 52, 
	16, 15, 21, 3, 7, 50, 51, 13, 
	6, 198, 198, 140, 25, 65, 64, 66, 
	67, 69, 65, 64, 66, 67, 198, 198, 
	101, 103, 39, 82, 84, 115, 118, 101, 
	107, 109, 82, 91, 93, 115, 128, 127, 
	165, 166, 192, 180, 181, 187, 179, 184, 
	195, 193, 172, 161, 186, 148, 158, 173, 
	163, 178, 189, 149, 160, 177, 147, 58, 
	54, 4, 8, 5, 57, 49, 143, 188, 
	190, 191, 142, 208, 196, 208, 208, 209, 
	208, 208, 210, 197, 210, 210, 211, 210, 
	210, 212, 212, 212, 212, 213
};

static final short[] _hpricot_scan_trans_actions_wi = {
	0, 0, 0, 7, 0, 21, 0, 0, 
	7, 7, 0, 65, 0, 31, 0, 67, 
	0, 0, 1, 0, 63, 132, 178, 0, 
	144, 147, 0, 174, 23, 186, 0, 21, 
	0, 0, 0, 21, 144, 0, 111, 0, 
	111, 147, 0, 174, 23, 186, 147, 0, 
	174, 23, 186, 0, 0, 0, 144, 0, 
	21, 21, 0, 9, 9, 102, 73, 162, 
	9, 9, 174, 117, 0, 170, 0, 9, 
	9, 7, 102, 205, 174, 117, 215, 0, 
	9, 9, 102, 205, 174, 117, 215, 0, 
	9, 9, 7, 7, 102, 205, 174, 117, 
	215, 11, 0, 108, 11, 210, 11, 0, 
	108, 11, 210, 11, 0, 108, 11, 210, 
	105, 105, 0, 158, 11, 195, 105, 105, 
	0, 158, 11, 232, 105, 105, 0, 158, 
	11, 232, 105, 105, 0, 158, 11, 232, 
	3, 3, 3, 0, 0, 87, 120, 3, 
	3, 190, 3, 3, 3, 0, 7, 87, 
	3, 3, 190, 3, 3, 190, 87, 200, 
	3, 3, 182, 3, 3, 3, 3, 3, 
	3, 3, 7, 0, 87, 3, 3, 190, 
	3, 3, 190, 87, 200, 3, 3, 3, 
	7, 7, 87, 3, 3, 190, 3, 75, 
	3, 190, 87, 200, 3, 3, 84, 99, 
	78, 78, 0, 0, 150, 154, 78, 78, 
	0, 7, 150, 154, 78, 78, 220, 226, 
	78, 78, 7, 0, 150, 154, 78, 78, 
	220, 226, 78, 78, 7, 7, 150, 154, 
	78, 78, 75, 220, 226, 99, 69, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	13, 0, 15, 0, 17, 0, 0, 3, 
	3, 0, 0, 0, 0, 0, 0, 0, 
	3, 3, 0, 0, 0, 49, 71, 0, 
	0, 0, 0, 19, 51, 19, 0, 0, 
	0, 0, 0, 1, 0, 0, 0, 0, 
	55, 0, 114, 0, 53, 0, 19, 3, 
	3, 81, 5, 0, 5, 93, 5, 0, 
	90, 5, 5, 0, 96, 0, 0, 0, 
	1, 25, 25, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 61, 59, 0, 0, 0, 174, 23, 
	0, 0, 11, 0, 108, 11, 166, 57, 
	0, 0, 0, 0, 0, 0, 0, 9, 
	9, 0, 9, 9, 0, 9, 9, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	3, 3, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 3, 
	3, 0, 0, 35, 0, 33, 123, 31, 
	37, 135, 41, 0, 39, 126, 31, 43, 
	138, 47, 141, 45, 129, 0
};

static final short[] _hpricot_scan_to_state_actions = {
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 27, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	27, 0, 27, 0, 27, 0
};

static final short[] _hpricot_scan_from_state_actions = {
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 29, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	29, 0, 29, 0, 29, 0
};

static final int hpricot_scan_start = 198;

static final int hpricot_scan_error = -1;


public final static int BUFSIZE=16384;

private void rb_yield_tokens(IRubyObject sym, IRubyObject tag, IRubyObject attr, IRubyObject raw, boolean taint) {
  IRubyObject ary;
  if (sym == runtime.newSymbol("text")) {
    raw = tag;
  }
  ary = runtime.newArray(new IRubyObject[]{sym, tag, attr, raw});
  if (taint) { 
    ary.setTaint(true);
    tag.setTaint(true);
    attr.setTaint(true);
    raw.setTaint(true);
  }
  runtime.getCurrentContext().yield(ary, block);
}


int cs, act, have = 0, nread = 0, curline = 1, p=-1;
boolean text = false;
int tokstart=-1, tokend;
char[] buf;
IRuby runtime;
IRubyObject attr, bufsize;
IRubyObject[] tag, akey, aval;
int mark_tag, mark_akey, mark_aval;
boolean done = false, ele_open = false;
int buffer_size = 0;        
boolean taint = false;
Block block = null;


IRubyObject xmldecl, doctype, procins, stag, etag, emptytag, comment,
      cdata, sym_text;

IRubyObject hpricot_scan(IRubyObject recv, IRubyObject port) {
  attr = bufsize = runtime.getNil();
  tag = new IRubyObject[]{runtime.getNil()};
  akey = new IRubyObject[]{runtime.getNil()};
  aval = new IRubyObject[]{runtime.getNil()};

  RubyClass rb_eHpricotParseError = runtime.getModule("Hpricot").getClass("ParseError");

  taint = port.isTaint();
  if ( !port.respondsTo("read")) {
    if ( port.respondsTo("to_str")) {
      port = port.callMethod(runtime.getCurrentContext(),"to_str");
    } else {
      throw runtime.newArgumentError("bad argument, String or IO only please.");
    }
  }

  buffer_size = BUFSIZE;
  if (recv.getInstanceVariable("@buffer_size") != null) {
    bufsize = recv.getInstanceVariable("@buffer_size");
    if (!bufsize.isNil()) {
      buffer_size = RubyNumeric.fix2int(bufsize);
    }
  }
  buf = new char[buffer_size];

  
	{
	cs = hpricot_scan_start;
	tokstart = -1;
	tokend = -1;
	act = 0;
	}

  while( !done ) {
    IRubyObject str;
    p = have;
    int pe;
    int len, space = buffer_size - have;

    if ( space == 0 ) {
      /* We've used up the entire buffer storing an already-parsed token
       * prefix that must be preserved.  Likely caused by super-long attributes.
       * See ticket #13. */
      rb_raise(rb_eHpricotParseError, "ran out of buffer space on element <" + tag.toString() + ">, starting on line "+curline+".");
    }

    if (port.respondsTo("read")) {
      str = port.callMethod(runtime.getCurrentContext(),"read",runtime.newFixnum(space));
    } else {
      str = ((RubyString)port).substr(nread,space);
    }

    str = str.convertToString();
    String sss = str.toString();
    char[] chars = sss.toCharArray();
    System.arraycopy(chars,0,buf,p,chars.length);

    len = sss.length();
    nread += len;

    if ( len < space ) {
      len++;
      done = true;
    }

    pe = p + len;
    char[] data = buf;

    
	{
	int _klen;
	int _trans;
	int _acts;
	int _nacts;
	int _keys;

	if ( p != pe ) {
	_resume: while ( true ) {
	_again: do {
	_acts = _hpricot_scan_from_state_actions[cs];
	_nacts = (int) _hpricot_scan_actions[_acts++];
	while ( _nacts-- > 0 ) {
		switch ( _hpricot_scan_actions[_acts++] ) {
	case 21:
	{tokstart = p;}
	break;
		}
	}

	_match: do {
	_keys = _hpricot_scan_key_offsets[cs];
	_trans = _hpricot_scan_index_offsets[cs];
	_klen = _hpricot_scan_single_lengths[cs];
	if ( _klen > 0 ) {
		int _lower = _keys;
		int _mid;
		int _upper = _keys + _klen - 1;
		while (true) {
			if ( _upper < _lower )
				break;

			_mid = _lower + ((_upper-_lower) >> 1);
			if ( data[p] < _hpricot_scan_trans_keys[_mid] )
				_upper = _mid - 1;
			else if ( data[p] > _hpricot_scan_trans_keys[_mid] )
				_lower = _mid + 1;
			else {
				_trans += (_mid - _keys);
				break _match;
			}
		}
		_keys += _klen;
		_trans += _klen;
	}

	_klen = _hpricot_scan_range_lengths[cs];
	if ( _klen > 0 ) {
		int _lower = _keys;
		int _mid;
		int _upper = _keys + (_klen<<1) - 2;
		while (true) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( data[p] < _hpricot_scan_trans_keys[_mid] )
				_upper = _mid - 2;
			else if ( data[p] > _hpricot_scan_trans_keys[_mid+1] )
				_lower = _mid + 2;
			else {
				_trans += ((_mid - _keys)>>1);
				break _match;
			}
		}
		_trans += _klen;
	}
	} while (false);

	_trans = _hpricot_scan_indicies[_trans];
	cs = _hpricot_scan_trans_targs_wi[_trans];

	if ( _hpricot_scan_trans_actions_wi[_trans] == 0 )
		break _again;

	_acts = _hpricot_scan_trans_actions_wi[_trans];
	_nacts = (int) _hpricot_scan_actions[_acts++];
	while ( _nacts-- > 0 )
	{
		switch ( _hpricot_scan_actions[_acts++] )
		{
	case 0:
	{
    if (text) {
      CAT(tag, p);
      ELE(sym_text);
      text = false;
    }
    attr = runtime.getNil();
    tag[0] = runtime.getNil();
    mark_tag = -1;
    ele_open = true;
  }
	break;
	case 1:
	{ mark_tag = p; }
	break;
	case 2:
	{ mark_aval = p; }
	break;
	case 3:
	{ mark_akey = p; }
	break;
	case 4:
	{ SET(tag, p); }
	break;
	case 5:
	{ SET(aval, p); }
	break;
	case 6:
	{ 
    if (buf[p-1] == '"' || buf[p-1] == '\'') { SET(aval, p-1); }
    else { SET(aval, p); }
  }
	break;
	case 7:
	{ SET(akey, p); }
	break;
	case 8:
	{ SET(aval, p); ATTR(rb_str_new2("version"), aval); }
	break;
	case 9:
	{ SET(aval, p); ATTR(rb_str_new2("encoding"), aval); }
	break;
	case 10:
	{ SET(aval, p); ATTR(rb_str_new2("standalone"), aval); }
	break;
	case 11:
	{ SET(aval, p); ATTR(rb_str_new2("public_id"), aval); }
	break;
	case 12:
	{ SET(aval, p); ATTR(rb_str_new2("system_id"), aval); }
	break;
	case 13:
	{ 
    akey[0] = runtime.getNil();
    aval[0] = runtime.getNil();
    mark_akey = -1;
    mark_aval = -1;
  }
	break;
	case 14:
	{ 
    ATTR(akey, aval);
  }
	break;
	case 15:
	{curline += 1;}
	break;
	case 16:
	{ TEXT_PASS(); }
	break;
	case 17:
	{ EBLK(comment, 3); {cs = 198; if (true) break _again;} }
	break;
	case 18:
	{ EBLK(cdata, 3); {cs = 198; if (true) break _again;} }
	break;
	case 19:
	{ EBLK(procins, 2); {cs = 198; if (true) break _again;} }
	break;
	case 22:
	{tokend = p+1;}
	break;
	case 23:
	{tokend = p+1;{p = ((tokend))-1;}}
	break;
	case 24:
	{tokend = p+1;{ TEXT_PASS(); }{p = ((tokend))-1;}}
	break;
	case 25:
	{tokend = p;{ TEXT_PASS(); }{p = ((tokend))-1;}}
	break;
	case 26:
	{{ TEXT_PASS(); }{p = ((tokend))-1;}}
	break;
	case 27:
	{tokend = p+1;{p = ((tokend))-1;}}
	break;
	case 28:
	{tokend = p+1;{ TEXT_PASS(); }{p = ((tokend))-1;}}
	break;
	case 29:
	{tokend = p;{ TEXT_PASS(); }{p = ((tokend))-1;}}
	break;
	case 30:
	{{ TEXT_PASS(); }{p = ((tokend))-1;}}
	break;
	case 31:
	{tokend = p+1;{p = ((tokend))-1;}}
	break;
	case 32:
	{tokend = p+1;{ TEXT_PASS(); }{p = ((tokend))-1;}}
	break;
	case 33:
	{tokend = p;{ TEXT_PASS(); }{p = ((tokend))-1;}}
	break;
	case 34:
	{act = 8;}
	break;
	case 35:
	{act = 10;}
	break;
	case 36:
	{act = 12;}
	break;
	case 37:
	{act = 15;}
	break;
	case 38:
	{tokend = p+1;{ ELE(xmldecl); }{p = ((tokend))-1;}}
	break;
	case 39:
	{tokend = p+1;{ ELE(doctype); }{p = ((tokend))-1;}}
	break;
	case 40:
	{tokend = p+1;{ ELE(stag); }{p = ((tokend))-1;}}
	break;
	case 41:
	{tokend = p+1;{ ELE(etag); }{p = ((tokend))-1;}}
	break;
	case 42:
	{tokend = p+1;{ ELE(emptytag); }{p = ((tokend))-1;}}
	break;
	case 43:
	{tokend = p+1;{ {{p = ((tokend))-1;}{cs = 208; if (true) break _again;}} }{p = ((tokend))-1;}}
	break;
	case 44:
	{tokend = p+1;{ {{p = ((tokend))-1;}{cs = 210; if (true) break _again;}} }{p = ((tokend))-1;}}
	break;
	case 45:
	{tokend = p+1;{ TEXT_PASS(); }{p = ((tokend))-1;}}
	break;
	case 46:
	{tokend = p;{ {{p = ((tokend))-1;}{cs = 212; if (true) break _again;}} }{p = ((tokend))-1;}}
	break;
	case 47:
	{tokend = p;{ TEXT_PASS(); }{p = ((tokend))-1;}}
	break;
	case 48:
	{{ {{p = ((tokend))-1;}{cs = 212; if (true) break _again;}} }{p = ((tokend))-1;}}
	break;
	case 49:
	{{ TEXT_PASS(); }{p = ((tokend))-1;}}
	break;
	case 50:
	{	switch( act ) {
	case 8:
	{ ELE(doctype); }
	break;
	case 10:
	{ ELE(stag); }
	break;
	case 12:
	{ ELE(emptytag); }
	break;
	case 15:
	{ TEXT_PASS(); }
	break;
	default: break;
	}
	{p = ((tokend))-1;}}
	break;
		}
	}

	} while (false);
	_acts = _hpricot_scan_to_state_actions[cs];
	_nacts = (int) _hpricot_scan_actions[_acts++];
	while ( _nacts-- > 0 ) {
		switch ( _hpricot_scan_actions[_acts++] ) {
	case 20:
	{tokstart = -1;}
	break;
		}
	}

	if ( ++p == pe )
		break _resume;
	}
	}
	}
    
    if ( cs == hpricot_scan_error ) {
      if(!tag[0].isNil()) {
        rb_raise(rb_eHpricotParseError, "parse error on element <"+tag.toString()+">, starting on line "+curline+".\n" + NO_WAY_SERIOUSLY);
      } else {
        rb_raise(rb_eHpricotParseError, "parse error on line "+curline+".\n" + NO_WAY_SERIOUSLY);
      }
    }
    
    if ( done && ele_open ) {
      ele_open = false;
      if(tokstart > -1) {
        mark_tag = tokstart;
        tokstart = -1;
        text = true;
      }
    }

    if(tokstart == -1) {
      have = 0;
      /* text nodes have no tokstart because each byte is parsed alone */
      if(mark_tag != -1 && text) {
        if (done) {
          if(mark_tag < p-1) {
            CAT(tag, p-1);
            ELE(sym_text);
          }
        } else {
          CAT(tag, p);
        }
      }
      mark_tag = 0;
    } else {
      have = pe - tokstart;
      System.arraycopy(buf,tokstart,buf,0,have);
      SLIDE(tag);
      SLIDE(akey);
      SLIDE(aval);
      tokend = (tokend - tokstart);
      tokstart = 0;
    }
  }
  return runtime.getNil();
}

public static IRubyObject __hpricot_scan(IRubyObject recv, IRubyObject port, Block block) {
  IRuby runtime = recv.getRuntime();
  HpricotScanService service = new HpricotScanService();
  service.runtime = runtime;
  service.xmldecl = runtime.newSymbol("xmldecl");
  service.doctype = runtime.newSymbol("doctype");
  service.procins = runtime.newSymbol("procins");
  service.stag = runtime.newSymbol("stag");
  service.etag = runtime.newSymbol("etag");
  service.emptytag = runtime.newSymbol("emptytag");
  service.comment = runtime.newSymbol("comment");
  service.cdata = runtime.newSymbol("cdata");
  service.sym_text = runtime.newSymbol("text");
  service.block = block;
  return service.hpricot_scan(recv, port);
}


public boolean basicLoad(final IRuby runtime) throws IOException {
       Init_hpricot_scan(runtime);
       return true;
}

public static void Init_hpricot_scan(IRuby runtime) {
  RubyModule mHpricot = runtime.defineModule("Hpricot");
  mHpricot.getMetaClass().attr_accessor(new IRubyObject[]{runtime.newSymbol("buffer_size")});
  CallbackFactory fact = runtime.callbackFactory(HpricotScanService.class);
  mHpricot.getMetaClass().defineMethod("scan",fact.getSingletonMethod("__hpricot_scan",IRubyObject.class));
  mHpricot.defineClassUnder("ParseError",runtime.getClass("Exception"),runtime.getClass("Exception").getAllocator());
}
}
